;Win32 programs run in protected mode, flat memory model, separate 4gb virtual space
;ALWAYS restore  esi, edi, ebp and ebx 
;ANSI (ascii) 1byte for letter UNICODE 2byte for letter
;
; WinF will preserve segment regs, edi, esi, ebp, ebx
;ecx and edx are destroyed
;eax has F. result

.386  ;.486 .586 .686 p=if U use privileged instructions

.MODEL Flat, STDCALL
;win32 use only flat mem model
;C = pass right to left (right byte is first pushed on to stack) caller balances stack!!! add sp,12
;PASCAL = pass parameter from left to right (left is first pushed) callee balance stack!!!
;STDCALL = right to left push to stack callee balance stack
option casemap:none ;labels are case-sensitive


   include \masm32\include\windows.inc
   include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
;Kernel32.dll contains API functions that deal with memory and process management

   include \masm32\include\user32.inc
includelib \masm32\lib\user32.lib
;User32.dll controls the user interface aspects

   include \masm32\include\gdi32.inc
includelib \masm32\lib\gdi32.lib
;Gdi32.dll is responsible for graphics operations




;WinMain proto :DWORD,:DWORD,:DWORD,:DWORD  ;win32 funkcija
;there's legend that U can make prg without winmain f.
;The Legend is TRUE :)


.DATA
ClassName db "DicWinClass",0  ;name of our window class. what's window class?
AppName db "Dictionary 0.0",0 ;string on 
CommandLine dd 0

wc dd sizeof WNDCLASSEX
   dd CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
   dd offset WndProc, 0, 0, 400000h, 0, 0
   dd COLOR_WINDOW +1, 0
   dd offset  ClassName, 0

;wc WNDCLASSEX <>
; WNDCLASSEX STRUCT
;  cbSize            DWORD      ?
;  style             DWORD      ?
;  lpfnWndProc       DWORD      ?
;  cbClsExtra        DWORD      ?
;  cbWndExtra        DWORD      ?
;  hInstance         DWORD      ?
;  hIcon             DWORD      ?
;  hCursor           DWORD      ?
;  hbrBackground     DWORD      ?
;  lpszMenuName      DWORD      ?
;  lpszClassName     DWORD      ?
;  hIconSm           DWORD      ?
; WNDCLASSEX ENDS


;wc.style dd CS_HREDRAW or CS_VREDRAW



;later load last position from file somehow
W1height dd 50
W1width dd 200
W1topX dd 0
W1topY dd 0
;nice if possible to use this file

szBin db "00000000000000000000000000000000",0
szTxt db "Weevil.",0
MouseClick db 0         ; 0=no click yet



;_____
.DATA?
;to preallocate some memory 
; MSG STRUCT
;  hwnd      DWORD      ?
;  message   DWORD      ?
;  wParam    DWORD      ?
;  lParam    DWORD      ?
;  time      DWORD      ?
;  pt        POINT      <>
; MSG ENDS

msg MSG <>
msg1 dd ?
hwnd dd ?
hInstance dd ? ; Instance handle of our program. Now there's only one :)
char dd ?
hitpoint POINT <>
cnt dd ?


;.CONST
;const can not be changed. could be usefull



.CODE
   Dictionary_:

;_______________________________
;to calculate position of window
        push SM_CXSCREEN
        call GetSystemMetrics
sub eax,W1width
mov W1topX,eax        
  ;      push SM_CYSCREEN
  ;      call GetSystemMetrics

;______________
;to lea msg MSG
lea eax,msg
mov msg1,eax


push 0
call GetModuleHandle ;get the instance handle of our program. ;Under Win32, hmodule = hinstance = ID of prg = linear address of your program in memory.
mov hInstance,eax
call GetCommandLine ;get the command line. don't call it IF prdoesn't process the commandline.
mov CommandLine,eax
;cmp len CommandLone,128
;jnge L1
;mov CommandLine,0
;L1:  somehow



;ExWinMain_____________________
;mov wc.cbSize,SIZEOF WNDCLASSEX 
; mov wc.style, CS_HREDRAW or CS_VREDRAW ; style of window , use or
;mov wc.lpfnWndProc, OFFSET WndProc ;This is what decode message in loop!
;mov wc.cbClsExtra,NULL ;???
;mov wc.cbWndExtra,NULL ; ???

push hInstance ; = hInstance why not simply use hInstance???
pop wc.WNDCLASSEX.hInstance ;
;mov wc.hbrBackground,COLOR_WINDOW +1 ;
;mov wc.lpszMenuName,NULL       ;pointer to zs name of menu class NULL no menu :)
;mov wc.lpszClassName,OFFSET ClassName ;pointer fo zs class name

push IDI_QUESTION	;IDI_WARNING ;does not work, IDI_EXCLAMATION ;IDI_APPLICATION
push hInstance
call LoadIcon
mov wc.WNDCLASSEX.hIcon,eax      ;handle of icon for your prg
mov wc.WNDCLASSEX.hIconSm,0 ;eax    ;handle to small icon (same?)

push IDC_IBEAM ;txt cursor like
push 0 ;hInstance  or 0 for windef cursor
call LoadCursor
mov wc.WNDCLASSEX.hCursor,eax   

lea eax,wc ;address of wc structure
push eax
call RegisterClassEx   ;register our window class





push 0  ;pointer to data struct passed to win ?
push hInstance  ;=hInstance ???
push 0   ;manu handle
push 0 ; ;child window 0=no child
push W1height ;200 ;CW_USEDEFAULT  ; window HEIGHT !
push W1width ;100 ;CW_USEDEFAULT    ; window WIDTH !
push W1topY ;CW_USEDEFAULT  ;y  top left point
push W1topX ;CW_USEDEFAULT  ;x  top left point
push WS_VISIBLE or WS_POPUP or WS_BORDER  ;or WS_SIZEBOX ;;WS_EX_ABSPOSITION for stationary win ;window LOOKS important!
push offset AppName  ;0=empty
push offset ClassName ;lpClassName  address of  win class ?
push WS_EX_TOPMOST ; or WS_EX_TOOLWINDOW	;for no tab no taskbar handle

call CreateWindowEx
mov hwnd,eax ;handle of win?
;is this unique win handle?

;    push 600
 ;       push hInstance ;or hInstance :(
  ;      call LoadMenu
;        push eax
 ;       push hWnd
  ;      call SetMenu


          push SW_SHOWNORMAL ; =SW_SHOWDEFAUL
          push hwnd
          call ShowWindow ;display our window on desktop

push hwnd
call UpdateWindow ;refresh the client area


;_________________________________________________________
DictionaryLoop:
;inc cnt
push 0  ;wMsgFilterMax highest msg value :(
push 0  ;wMsgFilterMin  lowest msg value :(
push 0  ;hwnd of window NULL=any window of thread ???
;lea eax,msg ;for god sake WHY?
;push eax
push msg1    ;address of msg STRUCT
call GetMessage  ;put message in msg:MSG STRUCT

cmp eax,0   ;Exit prg if msg is 0
je ExitDictionary


;lea eax,msg ;why? doesn't eax = msg???
;push eax
push msg1
call TranslateMessage ;never modifyes msg! what if eax=0?


;lea eax, msg  ; WHY???
;push eax
push msg1
call DispatchMessage ;put msg in WinProc ?

jmp DictionaryLoop

ExitDictionary:
;mov eax,msg.wParam ;return exit code in eax
;push eax
push msg.wParam
call ExitProcess ;quit our program. The exit code is returned in eax from WinMain. But if U have no winmain  push msg.wParam is perfect :D
;______________________________________________________________




;______________________________________________________________
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT


next3:

cmp uMsg,WM_LBUTTONDOWN
jne next2
            mov eax,lParam
      	and eax,0ffffh
      	mov hitpoint.x,eax
      	mov eax,lParam
      	shr eax,16
      	mov hitpoint.y,eax
      	mov MouseClick,TRUE
      	invoke InvalidateRect,hWnd,NULL,TRUE
      







next2:
              cmp uMsg, WM_CHAR
              jne next1
              push wParam
              pop char
              invoke InvalidateRect, hWnd,NULL,TRUE
              
next1:
cmp uMsg, WM_PAINT
jne PreKill

     invoke BeginPaint,hWnd, ADDR ps
      mov    hdc,eax
invoke TextOut,hdc,0,0,ADDR char,1 ;add
         invoke GetClientRect,hWnd, ADDR rect
         invoke DrawText, hdc,ADDR szTxt,-1, ADDR rect, DT_SINGLELINE or DT_CENTER or DT_VCENTER

 cmp MouseClick, TRUE
 jne nopaint
invoke lstrlen,ADDR AppName
invoke TextOut,hdc,hitpoint.x,hitpoint.y,ADDR AppName,eax

         
         nopaint:
         invoke EndPaint,hWnd, ADDR ps



PreKill:
   cmp uMsg, WM_CLOSE
   jne DestroyPrg



push MB_YESNO
push CommandLine ; caption
push OFFSET szBin ;txt
push hWnd
call MessageBox
 cmp eax, IDNO  ; suppose cmp eax, IDYES je DestroyPrg works too.
 jne DestroyPrg
  xor eax,eax
  ret

DestroyPrg:
   cmp uMsg, WM_DESTROY
   jne last
;push wParam instead of NULL???   
push 0
call PostQuitMessage ; wParam of WM_QUIT message?
xor eax,eax
ret

 last:
push lParam
push wParam
push uMsg
push hWnd
call DefWindowProc ;eats all other messages :)
 ret

WndProc endp
   end Dictionary_